﻿/*
 * Created by SharpDevelop.
 * User: david
 * Date: 27.06.2015
 * Time: 10:07
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Net;
using System.IO;
using System.Threading;

namespace lovcipokladu
{
	class Program
	{
		struct Player { // struktura definujici vlastnosti hrace
			public int x;
			public int y;
			public int carry;
			public int treasure;
		}
		
		public static void Main(string[] args)
		{
			Console.WindowWidth = 80;
			Console.WindowHeight = 10;
			
			
			string addr = "";
			
			Console.BackgroundColor = ConsoleColor.Yellow;
			Console.ForegroundColor = ConsoleColor.Black;
			Console.WriteLine("Klient hry Lovci Pokladu - Z3 David Indra");
			Console.BackgroundColor = ConsoleColor.Black;
			Console.ForegroundColor = ConsoleColor.White;
			Console.WriteLine("Ovladani je pomoci N, D, L, P");
			Console.WriteLine("Cilem je nasbirat co nejvice pokladu tim, ze je vezmes a polozis na zakladnu");
			Console.Write("Prosim, zadejte adresu serveru (ip:port) (vychozi je localhost:8000): "); // nacteni serveru
			string tmp = Console.ReadLine();
			if(tmp == ""){
				addr = "localhost:8000/";
			}else{
				addr = "" + tmp + "/";
			}
			
			
			string[] response = do_request(addr + "start");
			
			again:;
			if(response.Length < 5){
				Console.Clear();
				Console.WindowWidth = 70;
				Console.WindowHeight = 10;
				Console.ForegroundColor = ConsoleColor.White;
				Console.BackgroundColor = ConsoleColor.Black;
				string[] vysl = response[0].Split(' ');
				Console.WriteLine(); Console.WriteLine();
				Console.WriteLine("KONEC HRY :) tvoje skore: " + vysl[2] + ", jeho skore: " + vysl[3]);
				Console.WriteLine("pro ukonceni stisknete libovolnou klavesu");
				Console.ReadKey();
			}
			
			long gameid = Convert.ToInt64(response[0]);
			
			int remaining_moves = Convert.ToInt32(response[1]);
			
			Player you = new Player();
			Player enemy = new Player();
			
			Console.Clear();
			Console.WindowWidth = 21;
			Console.WindowHeight = 15;
			Console.ForegroundColor = ConsoleColor.White;
			Console.BackgroundColor = ConsoleColor.Black;
			
			char[,] map = new char[10,10];
			
			int i = 0;
			foreach (string line in response) { 		// vyreseni nacteni odpovedi do mapy
				if(i >= 2 && i <= 11){
					char[] arr = line.ToCharArray();
					for(int y = 0; y < 10; y++){
						map[y,i-2] = arr[y*2+1];
					}
				}
				if(i == 12){ // definice hrace
					string[] arr = line.Split(' ');
					you.x = Convert.ToInt32(arr[0]);
					you.y = Convert.ToInt32(arr[1]);
					you.carry = Convert.ToInt32(arr[2]);
					you.treasure = Convert.ToInt32(arr[3]);
				}
				
				if(i == 13 && line != "\n"){ // definice nepritele
					string[] arr = line.Split(' ');
					enemy.x = Convert.ToInt32(arr[0]);
					enemy.y = Convert.ToInt32(arr[1]);
					enemy.carry = Convert.ToInt32(arr[2]);
					enemy.treasure = Convert.ToInt32(arr[3]);
				}
				
				i++;
			}
			
			for (int y = 0; y < map.GetLength(0); y++){			// samotny vypis mapy
				for (int x = 0; x < map.GetLength(1); x++){
					string prn = "";
					switch(map[x, y]){
						case 'X':
							Console.ForegroundColor = ConsoleColor.DarkGray;
							prn = "██";
							break;
						case '.':
							Console.ForegroundColor = ConsoleColor.White;
							prn = "  ";
							break;
						case '+':
							Console.ForegroundColor = ConsoleColor.Red;
							prn = "++";
							break;
						case '-':
							Console.ForegroundColor = ConsoleColor.Blue;
							prn = "--";
							break;
						default:
							Console.ForegroundColor = ConsoleColor.Yellow;
							prn = response[y+2].ToCharArray()[x*2+1].ToString() + response[y+2].ToCharArray()[x*2+2].ToString();
							break;
					}
					
					if(x == you.x-1 && y == you.y-1){
						Console.ForegroundColor = ConsoleColor.White;
						prn = "JA";
					}
					
					if(x == enemy.x-1 && y == enemy.y-1){
						Console.ForegroundColor = ConsoleColor.White;
						prn = "ON";
					}
										
					Console.Write(string.Format("{0}", prn));
				}
				Console.WriteLine();
			}
			Console.BackgroundColor = ConsoleColor.Red;
			Console.ForegroundColor = ConsoleColor.Black;
			Console.WriteLine("                    ");
			Console.BackgroundColor = ConsoleColor.White;
			Console.ForegroundColor = ConsoleColor.DarkBlue;
			string spc = ""; // vypocet mezer pro formatovani doplnujicich textu
			for(int s = 0; s < (20 - Math.Round((double)(you.carry.ToString().Length - enemy.carry.ToString().Length - 6)))/4-1; s++){
				spc += " ";
			}
			Console.WriteLine(you.carry + spc + "prenos" + spc + enemy.carry);
			spc = "";
			for(int s = 0; s < (20 - Math.Round((double)(you.treasure.ToString().Length - enemy.treasure.ToString().Length - 5)))/4-1; s++){
				spc += " ";
			}
			Console.WriteLine(you.treasure + spc + "skore" + spc + enemy.treasure);
			
			Console.WriteLine("zbyv. tahy: " + remaining_moves);
			
			badchar:;
			char key = Console.ReadKey(true).KeyChar; 
			if(key == 'n' && ( // kontroly validity pohybu
					/*(map[you.x-1,you.y-2] == '-' || map[you.x-1,you.y-2] == 'X') ||*/ //BOHUZEL, rozbila se mi kontrola vedl. bloku
					(you.x == enemy.x && you.y - 1 == enemy.y) ||
					you.y == 1)
				|| key == 'd' && (
					/*(map[you.x-1,you.y-0] == '-' || map[you.x-1,you.y-0] == 'X') ||*/
					(you.x == enemy.x && you.y + 1 == enemy.y) ||
					you.y == 10)
					
				|| key == 'l' && (
					/*(map[you.x-2,you.y-1] == '-' || map[you.x-2,you.y-1] == 'X') ||*/
					(you.x + 1 == enemy.x && you.y == enemy.y) ||
					you.x == 1)
				|| key == 'p' && (
					/*(map[you.x-0,you.y-1] == '-' || map[you.x-0,you.y-1] == 'X') ||*/
					(you.x - 1 == enemy.x && you.y == enemy.y) ||
					you.x == 10)
				
				){ //volno, vl. zakladna, poklad
				Console.SetCursorPosition(7, 14);
				Console.Write("NELZE!");
				System.Threading.Thread.Sleep(400);
				goto badchar;
			}else{
				if(key == 'n' || key == 'd' || key == 'l' || key == 'p'){
					response = do_request(addr + "tah?id=" + gameid.ToString() + "&pohyb=" + key.ToString());
					goto again;
				}else{
					goto badchar;
				}
			}
		}
		
		public static string[] do_request(string addr){ 			// funkce, ktera zpracuje pozadavek k serveru
			HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://" + addr);
			req.Method = "GET";
			req.Accept = "*/*";
			req.ContentType = "text/plain";
			req.Timeout = 1000*60;
			HttpWebResponse response = (HttpWebResponse)req.GetResponse();
			Stream str = response.GetResponseStream();
			StreamReader readStream = new StreamReader( str, System.Text.Encoding.GetEncoding("utf-8"));
			Char[] read = new Char[256];    
			int count = readStream.Read( read, 0, 256 );
			string result = "";
			while (count > 0)
				{
					String st = new String(read, 0, count);
					result += st;
					count = readStream.Read(read, 0, 256);
				}
			response.Close();
			readStream.Close();
			
			return result.Split('\r');
		}
	}
}